<?
define ('table_legend_title', 'key');
define ('table_no_records', '<p> </p>');

class Table {
	
	var $table,$tableAttr='border="1"',$seriescount,$seriesarray;
	var $dateFormat,$heads,$headClass,$totClass;
	var $subTotClass,$colClass,$rowClass,$fieldCount;
	var $classMode,$attrSet=false;
	var $wantSubTots = false,$counts,$hasTotClass;
	var $hasSubTotClass,$onChangeCol=-1,$onChangeVal='',$blankOnChange=0;
	var $align,$widths,$decpl,$links,$conditions,$datefield,$hiddenColumns;
	var $legend,$hasLegend=false,$GPCols,$spans,$showHeadings=true;

/*===============================================================================
 
===============================================================================*/
function Table() {

	$this->classMode = '';
	$this->dateFormat = 'd M y';
return;
}

/*===============================================================================
   
===============================================================================*/
function setTableAttr($attr) {

	$this->tableAttr = $attr;
	$this->attrSet = true;
return;
}

/*===============================================================================
   
===============================================================================*/
function setHeadings($h) {
	
	if (is_array($h)) {
		$this->heads = $h;
	} else {
		$this->heads = explode('|',$h);
	}
	for ($i=0; $i < count($this->heads); $i++) {
		$this->heads[$i] = nl2br($this->heads[$i]);
	}
return;
}

/*===============================================================================
   
===============================================================================*/
function setHeaderClass($cl) {

	if (is_array($cl)) {
		$this->headClass = $cl;
	}
	else {
		$this->headClass = explode('|',$cl);
	}
	if (!$this->attrSet) $this->tableAttr = '';
return;
}

/*===============================================================================
   
===============================================================================*/
function setColClass($cl) {

	if (is_array($cl)) {
		$this->colClass = $cl;
	}
	else {
		$this->colClass = explode('|',$cl);
	}
	$this->classMode = 'C';
	if (!$this->attrSet) $this->tableAttr = '';
return;
}

/*===============================================================================
   
===============================================================================*/
function setRowClass($cl) {

	if (is_array($cl)) {
		$this->rowClass = $cl;
	}
	else {
		$this->rowClass = explode('|',$cl);
	}
	$this->classMode = 'R';
	if (!$this->attrSet) $this->tableAttr = '';
return;
}

/*===============================================================================
   
===============================================================================*/
function setWidth($colno, $w) {

	$this->widths[$colno] = $w;
return;
}

/*===============================================================================
   
===============================================================================*/
function setDateFormat($format) {

	$this->dateFormat = $format;
return;
}

/*===============================================================================
   
===============================================================================*/
function setAlign($colno,$aval) {

	switch ($aval) {
		case 'c':
		case 'C': $this->align[$colno] = 'center'; break;
		case 'l':
		case 'L': $this->align[$colno] = 'left'; break;
		case 'r':
		case 'R': $this->align[$colno] = 'right'; break;
		default: $this->align[$colno] = 'left'; break;
	}
return;
}

/*===============================================================================
    
===============================================================================*/
function setDecPlaces($colno, $dec, $align='R') {

	$this->decpl[$colno] = $dec;
	$this->setAlign($colno, $align);
return;
}

/*===============================================================================
     
===============================================================================*/
function setCount($colno) {

	$this->counts[$colno] = 0;
return;
}

/*===============================================================================
        
===============================================================================*/
function setOnChange($colno, $subTots = false, $blank = 0) {

	$this->onChangeCol = $colno;
	$this->onChangeVal = '';
	$this->wantSubTots = $subTots;
	$this->blankOnChange = $blank;
return;
}

/*===============================================================================
    
===============================================================================*/
function setCondition($colno,$test,$value,$bgcolor,$fgcolor,$legend='') {

	$count = count($this->conditions[$colno]);
	$this->conditions[$colno][$count]['test'] = $test;
	$this->conditions[$colno][$count]['value'] = $value;
	$this->conditions[$colno][$count]['bgcolor'] = $bgcolor;
	$this->conditions[$colno][$count]['fgcolor'] = $fgcolor;
	if ($legend != '') {
		$l = count($this->legend);
		$this->legend[$l]['text'] = $legend;
		$this->legend[$l]['bg'] = $bgcolor;
		$this->legend[$l]['fg'] = $fgcolor;
		$this->hasLegend = true;
	}
return;
}

/*===============================================================================
   
===============================================================================*/
function setLink($colno, $url) {

	$this->links[$colno] = $url;
return;
}

/*===============================================================================
   
===============================================================================*/
function hideColumn($colno) {

	$this->hiddenColumns[$colno] = 1;
return;
}

/*===============================================================================
     
===============================================================================*/
function setGPCol($colno, $content='') {

	$this->GPCols[$colno] = $content;
return;
}

/*===============================================================================
   
===============================================================================*/
function setSpan($colno, $newrow, $cspan=1, $rspan=1) {

	$this->spans[$colno]['row'] = $colno==0 ? 0 : $newrow;
	$this->spans[$colno]['cspan'] = $cspan;
	$this->spans[$colno]['rspan'] = $rspan;
return;
}

/*===============================================================================
  
===============================================================================*/
function addDataSeries($series) {

	$this->seriescount++;
	$this->seriesarray[]=$series;
}

/*===============================================================================
  /  
===============================================================================*/
function drawTable($filename) {

	$this->fieldCount = count($this->heads);
	
	if (isset($this->headClass) && $this->headClass) 
		$this->_padWithLast($this->headClass,$fcount);
	if (isset($this->totClass) && $this->totClass)
		$this->_padWithLast($this->totClass,$fcount);
	if (isset($this->subTotClass) && $this->subTotClass)
		$this->_padWithLast($this->subTotClass,$fcount);
	if ($this->classMode=='C')
		$this->_padWithLast($this->colClass,$fcount);
	$this->_chkHeads($farray,$fcount);
	$this->table = "\n<table ".$this->tableAttr." >\n";
	$this->_printHeadings();
	$this->_printData();
	if ($this->hasLegend)
		$this->_printLegend();
	$this->table .= "\n</table>\n";

	header("Content-Type: text/html; charset=windows-1251");

	if ($filename!='')	{ $fp = fopen($filename, 'w'); fwrite($fp,$this->table); fclose($fp); }
	else		{ print $this->table; }
	unset($this->table);
return;
}

/*===============================================================================
================================================================================
===============================================================================*/
function _printHeadings() {

	if (!$this->showHeadings) return;
	$this->table .= "\n<tr>\n";
	for ($c = 0; $c < $this->fieldCount; $c++) {
		if (isset($this->hiddenColumns[$c])) continue;

		$stxt = '';
		if (isset($this->spans[$c])) {
			if ($this->spans[$c]['row'] != 0) {
				$this->table .= "</tr>\n";
				$this->table .= "<tr>\n";
			}
			if ($this->spans[$c]['cspan'] > 1) {
				$stxt .= " colspan=\"" . $this->spans[$c]['cspan'] . "\" ";
			}
			if ($this->spans[$c]['rspan'] > 1) {
				$stxt .= " rowspan=\"" . $this->spans[$c]['rspan'] . "\" ";
			}
		}

		$this->table .= "<th";
		if (isset($this->headClass[$c])) $this->table .= " class=\"".$this->headClass[$c]."\"";
		$this->table .= $stxt.">";
		$this->table .= $this->heads[$c]."</th>\n";
	}
	$this->table .= "\n</tr>\n";
return;
}

function _printData() {

	$rowcount = 0;
	$rowClassCount = $this->classMode=='R'?count($this->rowClass):1;

	for ($z=0; $z<$this->seriescount; $z++) {
	
		$row = explode("|", $this->seriesarray[$z]);

		if ($this->onChangeCol != -1) {
			if (($row[$this->onChangeCol]!=$this->onChangeVal) && ($this->onChangeVal != '')) {
				if ($this->blankOnChange > 0) {
					$this->table .= "<tr><td>&nbsp;</td></tr>\n";
				}
				if ($this->blankOnChange == 2) {
					$this->_printHeadings();
				}
			}
		}
		if ($this->classMode=='R') {
			$this->table .= '<tr class="'.$this->rowClass[$rowcount % $rowClassCount].'">';
		}
		else $this->table .= "<tr>\n";

		for ($i=0; $i<$this->fieldCount; $i++) {
			if (isset($this->hiddenColumns[$i])) continue;
			$atxt = array();
			$stxt = '';
			if (isset($this->align[$i])) {
				$atxt[] = "text-align: {$this->align[$i]}";
			}
			if (isset($this->conditions[$i])) {
				if (($t = $this->_conditionTrue($row,$i)) != -1) {
					if ($this->conditions[$i][$t]['bgcolor'] != '')
						$atxt[] = "background:{$this->conditions[$i][$t]['bgcolor']}";
					if ($this->conditions[$i][$t]['fgcolor'] != '')
						$atxt[] = "color:{$this->conditions[$i][$t]['fgcolor']}";
				}
			}
			if (isset($this->widths[$i])) {
				$atxt[] = strpos($this->widths[$i],'%') ? "width : {$this->widths[$i]}" : "width : {$this->widths[$i]}px";
			}
			if (count($atxt)>0) {
				$stxt = "style = \"" . join('; ', $atxt) . "\" ";
			}

			if (isset($this->spans[$i])) {
				if ($this->spans[$i]['row'] != 0) {
					$this->table .= "</tr>\n";
					if ($this->classMode=='R') {
						$this->table .= '<tr class="'.$this->rowClass[$rowcount % $rowClassCount].'">';
					}
					else $this->table .= "<tr>\n";
				}
				if ($this->spans[$i]['cspan'] > 1) {
					$stxt .= " colspan=\"" . $this->spans[$i]['cspan'] . "\" ";
				}
				if ($this->spans[$i]['rspan'] > 1) {
					$stxt .= " rowspan=\"" . $this->spans[$i]['rspan'] . "\" ";
				}
			}


			if ($this->classMode=='C') {
				$this->table .= '<td class="'.$this->colClass[$i].'" '.$stxt.'>';
			}
			else $this->table .= "<td ".$stxt.">";
			$rowInc = 1;
			if (isset($row[$i])) {
				if (isset($this->datefield[$i])) {
					$cell = date($this->dateFormat,strtotime($row[$i]));
				}
				elseif (isset($this->decpl[$i]) && is_numeric($row[$i]))
					$cell = number_format($row[$i], $this->decpl[$i]);
				else
					$cell = stripslashes($row[$i]);

				if ($this->onChangeCol == $i) {
					$rowInc = 0;
					if ($row[$i]!=$this->onChangeVal) {
						$this->table .= $cell;
						$rowInc = 1;
					}
					else $this->table .= "&nbsp;";
					$this->onChangeVal = $row[$i];
				}
				elseif (isset($this->links[$i])) {
					$this->table .=  $this->_addHref($cell,$i,$row);
				}
				elseif (isset($this->GPCols[$i])) {
					$this->table .=  $this->_parseFields($cell,$row,$i);
				}
				else $this->table .= $cell;

			} else $this->table .= '&nbsp;';

			$this->table .= "</td>\n";
		}
		$this->table .= "</tr>\n";
		$rowcount++;
	}
	if ($rowcount == 0) {
		$this->table .= "</table><p>" . table_no_records . "</p>";
		return;
	}
	if ($this->blankOnChange) {
		$this->table .= "<tr><td>&nbsp;</td></tr>\n";
	}
return;
}

function _printLegend() {

	$this->table .= "<TABLE ".$this->tableAttr." >\n";
	$this->table .= "<TR><td colspan=\"3\">".table_legend_title."</td></TR>\n";
	foreach ($this->legend as $explan) {
		$this->table .=f ("<TR>\n<TD width=\"40\" STYLE=\"font-size:10pt; background: %s; color: %s\">Abc123</td><TD width=\"10\">&nbsp;</td><TD>%s</td>\n</TR>\n", $explan['bg'],$explan['fg'],$explan['text']);
	}
	$this->table .= "</table>\n";
return;
}

function _padWithLast(&$a, $n) {

	$val = $a[count($a)-1];
	$a = array_pad($a, $n, $val);
return;
}

function _chkHeads($farray,$fcount) {

	if ($fcount > count($this->heads)) {
		for ($i=count($this->heads); $i<$fcount; $i++) {
			$this->heads[$i] = $farray[$i];
		}
	}
return;
}

function _conditionTrue($row, $i) {

	$field = $row[$i];
	foreach ($this->conditions[$i] as $key=>$testdata) {
	$test = $testdata['test'];
	$val = $testdata['value'];
		if ( !$field || !$test || !$val )
			$res = -1;
		else {
			switch ($test) {
				case '#' :
					for ($f=count($row)-1; $f>=0; $f--) {
						$val = str_replace("#$f",$row[$f],$val);
					}
					$str = "return ($val);";
				break;
				case '?' :
					$str = "return(strpos('$field', '$val') !== false); ";
				break;
				case '!' :
					$str = "return(strpos('$field', '$val') === false); ";
				break;
				default :
					if (is_numeric($field))
						$str = "return($field $test $val); ";
					else
						$str = "return('$field' $test '$val'); ";
			}
			if (eval($str) ) {
				return $key;
			}
		}
	}
return -1;
}

function _addHref($cell,$col,$row) {

	$href = $this->links[$col];
	for ($f=count($row)-1; $f>=0; $f--) {
		$href = str_replace("#$f",$row[$f],$href);
	}

return "<a href=\"$href\" >$cell</a>";
}

function _parseFields($cell,$row, $col) {

	$cell = $this->GPCols[$col] == '' ? $cell : $this->GPCols[$col];
	for ($f=count($row)-1; $f>=0; $f--) {
		$cell = str_replace("#$f",$row[$f],$cell);
	}
return $cell;
}

}
?>